#include <iostream>
#include "../math/complex.hh"

extern "C" {
  void p1nspri_( double *p1plsn_r, double *p1plsn_i, 
		 double *p1minn_r, double *p1minn_i, 
		 double *p1valn_r, double *p1valn_i, 
		 double *n_r, double *n_i,
		 int *nf );
}

void p1nsp(complex *p1plsn, complex *p1minn, complex *p1valn, complex N, int nf) {
  double a1, a2, b1, b2, c1, c2;
  double nr = real(N), ni = imag(N);
  p1nspri_(&a1, &a2, &b1, &b2, &c1, &c2, &nr, &ni, &nf);
  *p1plsn = complex(a1,a2);
  *p1minn = complex(b1,b2);
  *p1valn = complex(c1,c2);
  return;
}

extern "C" {
  void p1ijpri_( double *p1psn_r, double *p1psn_i, 
		 double *p1qgn_r, double *p1qgn_i, 
		 double *p1gqn_r, double *p1gqn_i, 
		 double *p1ggn_r, double *p1ggn_i, 
		 double *n_r, double *n_i,
		 int *nf );
}

void p1ijp(complex *p1psn, complex *p1qgn, complex *p1gqn, complex *p1ggn, complex N, int nf) {
  double a1, a2, b1, b2, c1, c2, d1, d2;
  double nr = real(N), ni = imag(N);
  p1ijpri_(&a1, &a2, &b1, &b2, &c1, &c2, &d1, &d2, &nr, &ni, &nf);
  *p1psn = complex(a1,a2);
  *p1qgn = complex(b1,b2);
  *p1gqn = complex(c1,c2);
  *p1ggn = complex(d1,d2);
  return;
}


