#include "partonic_coefficients.hh"
//#include "math/math.hh"
#include <iostream>

using namespace std;



void CoeffFuncts::muF_2gg(double x1, double x2, double &gg[2], double &qg[2], double &qq[2]) {
  double C1qg = 0;//NFO_1_qg(N,mu);
  double C1gg = 0;//NFO_1_gg(N,mu);
  double C1qqb = 0;//NFO_1_qqb(N,mu);
  // singlet
  double C1SS = C1qqb/(2.*nf);
  // non-singlet
  double C1TT = C1qqb/2.;
  double C1VV = -C1qqb/2.;
  //
  double g0gg = 0;//M_PI*gamma0gg(N,_nf);
  double g0gq = 0;//M_PI*gamma0gq(N);
  double g0qg = 0;//M_PI*gamma0qg(N,_nf);
  double g0qq = 0;//M_PI*gamma0qq(N);
  //
  double g1gg = 0;//M_PI*M_PI*gamma1SGgg(N,_nf,g1s);
  double g1gq = 0;//M_PI*M_PI*gamma1SGgq(N,_nf,g1s);
  //
  gg[0] = (C1gg*(6*b0 - 4*g0gg) +4*b1 - 4*C1qg*g0qg -4*g1gg);    //*(-lf/2.)
  gg[1] = (3*pow(b0,2) - 5*b0*g0gg + 2*pow(g0gg,2) + g0gq*g0qg); //*pow(-lf,2);
  //
  qg[0] = (C1gg*g0gq + C1SS*g0qg + C1qg*(-3*b0 + g0gg + g0qq) + g1gq); //*lf
  qg[1] = g0gq*(-5*b0 + 3*g0gg + g0qq);//*pow(lf,2)/2.;
  //
  double FO2SS = 0;
  FO2SS += (C1SS*(3*b0 - 2*g0qq) - 2*C1qg*g0gq)*(-lf) + g0gq*g0gq*lf*lf;
  //
  double FO2TT = 0;
  FO2TT += C1TT*(3*b0 - 2*g0qq)*(-lf);
  //
  double FO2VV = 0;
  FO2VV += C1VV*(3*b0 - 2*g0qq)*(-lf);

}




double CoeffFuncts::conv_integrand(double x) {
  double x1 = current_z/x;
  double res = 0;
  //if(id_conv == 0) res = C2_bg(x) * Gamma1bg(x1,muF,mb);
  //if(id_conv == 1) res = C1_bg(x) * Gamma2bg(x1,muF,mb);
  //if(id_conv == 2) res = C1bb_Gamma1bg(x,muF,mb,mH,muR) * Gamma1bg(x1,muF,mb);
  //if(id_conv == 3) res = Gamma1bg(x,muF,mb) * Gamma2bg(x1,muF,mb);
  //if(id_conv == 4) res = C1_bg(x) * Gamma2bq(x1,muF,mb);
  //if(id_conv == 5) res = C2_bq(x) * Gamma1bg(x1,muF,mb);
  //if(id_conv == 6) res = Gamma1bg(x,muF,mb) * Gamma2bq(x1,muF,mb);
  return res/x;
}
double convolution_integrand(double x, void *par) {
  CoeffFuncts *p = (CoeffFuncts *) par;
  return p->conv_integrand(x);
}
double CoeffFuncts::convolution(double z) {
  current_z = z;
  return gauss(convolution_integrand, z, 1., 1.e-3, NULL, this);
}
void CoeffFuncts::initConvolutions(double xmin) {
  double xmax = 1 - 1e-8;
  interpolation_xmin = xmin;
  interpolation_xmax = xmax;
  sample_z = new double[Npoints];
  for(int j=0; j<Nsample; j++)
    sample_conv[j] = new double[Npoints];
  for(int i=0; i<Npoints; i++)
    sample_z[i] = xmin * exp((log(xmax)-log(xmin)) * i/(Npoints-1.));
  for(int j=0; j<Nsample; j++) {
    for(int i=0; i<Npoints; i++) {
      id_conv = j;
      sample_conv[j][i] = convolution(sample_z[i]);
      //if(j==6) cout << sample_z[i]  << "   " << sample_conv[j][i]<< endl;
    }
    cout << "."; cout.flush();
  }
  return;
}
double CoeffFuncts::C2bg_Gamma1bg(double z) {
  if(z<interpolation_xmin || z>1) cout << "x=" << z << " outside sampled region " << interpolation_xmin << "<x<1" << endl;
  if(z>interpolation_xmax) z = interpolation_xmax;
  return interpolate_cspline(sample_z, sample_conv[0], Npoints, z);
}
double CoeffFuncts::C1bg_Gamma2bg(double z) {
  if(z<interpolation_xmin || z>1) cout << "x=" << z << " outside sampled region " << interpolation_xmin << "<x<1" << endl;
  if(z>interpolation_xmax) z = interpolation_xmax;
  return interpolate_cspline(sample_z, sample_conv[1], Npoints, z);
}
double CoeffFuncts::C1bb_Gamma1bg_Gamma1bg(double z) {
  if(z<interpolation_xmin || z>1) cout << "x=" << z << " outside sampled region " << interpolation_xmin << "<x<1" << endl;
  if(z>interpolation_xmax) z = interpolation_xmax;
  return interpolate_cspline(sample_z, sample_conv[2], Npoints, z);
}
double CoeffFuncts::Gamma1bg_Gamma2bg(double z) {
  if(z<interpolation_xmin || z>1) cout << "x=" << z << " outside sampled region " << interpolation_xmin << "<x<1" << endl;
  if(z>interpolation_xmax) z = interpolation_xmax;
  return interpolate_cspline(sample_z, sample_conv[3], Npoints, z);
}
double CoeffFuncts::C1bg_Gamma2bq(double z) {
  if(z<interpolation_xmin || z>1) cout << "x=" << z << " outside sampled region " << interpolation_xmin << "<x<1" << endl;
  if(z>interpolation_xmax) z = interpolation_xmax;
  return interpolate_cspline(sample_z, sample_conv[4], Npoints, z);
}
double CoeffFuncts::C2bq_Gamma1bg(double z) {
  if(z<interpolation_xmin || z>1) cout << "x=" << z << " outside sampled region " << interpolation_xmin << "<x<1" << endl;
  if(z>interpolation_xmax) z = interpolation_xmax;
  return interpolate_cspline(sample_z, sample_conv[5], Npoints, z);
}
double CoeffFuncts::Gamma1bg_Gamma2bq(double z) {
  if(z<interpolation_xmin || z>1) cout << "x=" << z << " outside sampled region " << interpolation_xmin << "<x<1" << endl;
  if(z>interpolation_xmax) z = interpolation_xmax;
  return interpolate_cspline(sample_z, sample_conv[6], Npoints, z);
}




